PROJNAME = cd
LIBNAME = cd
#USE_RCS = YES
#DBG = Yes

INCTTF = freetype.h ft_conf.h ttcache.h ttcalc.h ttcmap.h \
  ttconfig.h ttengine.h ftnameid.h header.h \
  ttextend.h ttfile.h ttgload.h ttinterp.h \
  ttload.h ttmemory.h ttmutex.h ttobjs.h ttraster.h \
  tttables.h tttags.h tttypes.h fterrid.h ttdebug.h
INCTTF  := $(addprefix freetype/, $(INCTTF))

SRCTTF = ttapi.c ttcache.c ttcalc.c ttcmap.c \
  ttextend.c ttfile.c ttgload.c ttinterp.c \
  ttload.c ttmemory.c ttmutex.c ttobjs.c ttraster.c
SRCTTF  := $(addprefix freetype/, $(SRCTTF))

INCCGM = bparse.h cgm.h circle.h ellipse.h intcgm.h \
  intcgm2.h intcgm4.h intcgm6.h list.h sism.h \
  tparse.h types.h 
INCCGM  := $(addprefix intcgm/, $(INCCGM))

SRCCGM = bparse.c cgm.c circle.c ellipse.c intcgm1.c \
  intcgm2.c intcgm4.c intcgm6.c list.c \
  sism.c tparse.c 
SRCCGM  := $(addprefix intcgm/, $(SRCCGM))

SRCWIN32 = cdwclp.c cdwemf.c cdwimg.c cdwin.c cdwnative.c cdwprn.c cdwwmf.c wmf_emf.c cdwdbuf.c cdwdib.c
SRCWIN32  := $(addprefix win32/, $(SRCWIN32))

INCWIN32 = cdwin.h
INCWIN32  := $(addprefix win32/, $(INCWIN32))

SRCSIM := cdfontex.c sim.c simclip.c truetype.c vectortext.c
SRCSIM  := $(addprefix sim/, $(SRCSIM))

INCSIM = cdfontex.h sim.h truetype.h
INCSIM  := $(addprefix sim/, $(INCSIM))

#SRCMAC = cdmac.c macmem.c

SRCX11 = cdx11.c cdxclp.c cdximg.c cdxnative.c cdxdbuf.c xvertex.c
SRCX11  := $(addprefix x11/, $(SRCX11))

INCX11 = cdx11.h xvertex.h
INCX11  := $(addprefix x11/, $(INCX11))

SRCDRV = cddgn.c cdcgm.c cddxf.c cdirgb.c cdmf.c cdps.c
SRCDRV  := $(addprefix drv/, $(SRCDRV))

SRCNULL = cd0prn.c cd0emf.c cd0wmf.c
SRCNULL  := $(addprefix drv/, $(SRCNULL))

INCDRV = cdcgm.h cdclipbd.h cddgn.h cddxf.h cdemf.h cdimage.h cdirgb.h cdmf.h \
  cdnative.h cdprint.h cdps.h cdwmf.h cddbuf.h

SRCCOMM = cd.c wd.c wdhdcpy.c rgb2map.c
      
SRC = $(SRCCOMM) $(SRCCGM) $(SRCTTF) $(SRCDRV) $(SRCSIM)

ifeq "$(TEC_SYSNAME)" "Win32"
  SRC += $(SRCWIN32)
else
  SRC += $(SRCNULL) $(SRCX11)
  EXTRASRC = $(SRCWIN32)
endif

EXPINC1 = cd.h cdprivat.h wd.h $(INCDRV)
EXPINC1 := $(addprefix ../include/, $(EXPINC1))
  
INC = drv/cdmfpriv.h $(EXPINC) $(INCCGM) $(INCTTF) $(INCWIN32) $(INCX11)

INCLUDES = . drv x11 win32 intcgm freetype sim ../include

DEFINES = __CD__

.PHONY: co_all
co_all: $(INC) $(SRCCOMM) $(SRCCGM) $(SRCNULL) $(SRCX11) $(SRCDRV) $(SRCWIN32) $(SRCSIM)
